<?php

//adding DbOperacion file
 require_once '..\includes\DbOperacion.php';

 //response array
 $response = array();

 //if a get parameter named op is set we will consider it as an api call
 if(isset($_GET['opcion'])){

 //switching the get op value
 switch($_GET['opcion']){

case 'nuevoUsuario':
if(isset($_POST['nombre']) && isset($_POST['apellido_p'])&& isset($_POST['apellido_m'])&& isset($_POST['telefono'])&& isset($_POST['correo'])&& isset($_POST['password'])  ){
  $db = new DbOperacion();
  $usuario = $db->comprobarCorreo($_POST['correo']);
 if(count($usuario)>0){
   $response['error'] = true;
   $response['message'] = 'El correo ya se ha registrado, por favor ingrese otro';
 }else{
  //$db = new DbOperacion();
  if($db->agregarUsuario($_POST['nombre'], $_POST['apellido_p'], $_POST['apellido_m'],$_POST['telefono'],$_POST['correo'],$_POST['password'] )){
  $response['error'] = false;
  $response['message'] = 'El usuario se ha agregado correctamente';
 }else{
 $response['error'] = true;
 $response['message'] = 'Ocurrion un error al intentar agregar al usuario';
}
}
}else{
 $response['error'] = true;
 $response['message'] = 'Los parametros estan incompletos';
}
 break;
 
 case 'iniciarSesion':
 if(isset($_POST['correo']) && isset($_POST['password'])){
  // echo $_POST['correo']." ".$_POST['password'];
  $db = new DbOperacion();
  $usuario = $db->iniciarSesion($_POST['correo'], $_POST['password']);
 if(count($usuario)<=0){
   $response['error'] = true;
   $response['message'] = 'Usuario no valido';
 }else{
   $response['error'] = false;
   $response['message'] = 'Sesion iniciada Correctamente';
   $response['usuario'] = $usuario;
 }
 }else{
 $response['error'] = true;
 $response['message'] = 'Los parametros estan incompletos';
 }
 break;


 case 'verCitas':
 if(isset($_POST['id_paciente'])) {
  $db = new DbOperacion();
  $citas = $db->verCitas($_POST['id_paciente']);
 if(count($citas)<=0){
   $response['error'] = true;
   $response['message'] = 'No se ha encontrado ninguna cita';
 }else{
   $response['error'] = false;
   //$response['message'] = 'Se encontraron las siguientes citas';
   $response['citas'] = $citas;
 }
 }else{
 $response['error'] = true;
 $response['message'] = 'Los parametros estan incompletos';
 }
 break;
 
case 'nuevaCita':
if(isset($_POST['asunto']) && isset($_POST['descripcion'])&& isset($_POST['fecha'])&& isset($_POST['hora'])&& isset($_POST['id_paciente']) && isset($_POST['paciente'])){
//Variables de comprobación
$fechaZ = $_POST['fecha'];
$horaZ = $_POST['hora']; 

//Variables actuales de la fecha y hora
  date_default_timezone_set('America/Mexico_City');
	$fecha_actual1 = date("Y-m-d");
	$hora_actual1 = date("H:i");

//Variables para la hora (se ocupa sólo en el update)
	$hora_rest = strtotime('+2 hours', strtotime($hora_actual1)); 
	$hora_rest = date('H:i',$hora_rest);

//Variables de fecha actual + 2 horas...	
	$fecha_rest = strtotime('+2 days', strtotime($fecha_actual1)); 
	$fecha_rest = date("Y-m-d",$fecha_rest);

//Variables de horario disponible
	$hora_ac_ini1 = date ("08:59");
	$hora_ac_fin1 = date ("14:00");
	$hora_ac_ini2 = date ("16:59");
	$hora_ac_fin2 = date ("21:00");

//Variables para evitar citas entre horas
  //echo $horaZ."<br>";
  $db = new DbOperacion();
	$minuto = explode(":",$horaZ);
  $minutoZ = $minuto['1'];

  //Logica de comprobacion de todo!!!!
  if((($fecha_actual1 == $fechaZ) && ($horaZ > $hora_actual1 && $horaZ < $hora_rest)) || ($fecha_actual1 >= $fechaZ) ){
    $response['error'] = true;
    $response['message'] = 'Solo se pueden agendar citas 2 horas despues de la fecha y hora actual.';
  }else{
    
    $compHF = $db->comprobarFechaHora($fechaZ,$horaZ);
    if(count($compHF)>0){
        $response['error'] = true;
        $response['message'] = 'La fecha y hora de esa cita ya se ha registrado anteriormente.';
    }else{
      if($minutoZ>0){
        $response['error'] = true;
        $response['message'] = 'No puedes agendar citas entre horas.';
      }else{
        if( ( $horaZ > $hora_ac_ini1 && $horaZ < $hora_ac_fin1) || ($horaZ > $hora_ac_ini2 && $horaZ < $hora_ac_fin2) ){
          if($db->crearCita($_POST['asunto'] , $_POST['descripcion'], $_POST['fecha'], $_POST['hora'],$_POST['id_paciente'],$_POST['paciente'], "Pendiente") ){
            $response['error'] = false;
            $response['message'] = 'La cita se ha agendado correctamente';
           }else{
           $response['error'] = true;
           $response['message'] = 'Ocurrion un error al intentar agendar la cita';
          }    
      }else{
        $response['error'] = true;
        $response['message'] = 'Solo se pueden agendar citas de 9:00-14:00 y 17:00-21:00.';
      }
      }
    }
   }
 }else{
  $response['error'] = true;
  $response['message'] = 'Los parametros estan incompletos';
 }
break;

case 'editarCita':
if(isset($_POST['id_cita']) && isset($_POST['asunto']) && isset($_POST['descripcion'] )&& isset($_POST['fecha']) && isset($_POST['hora'])){
  
  //Variables de comprobación
  $id_cita = $_POST['id_cita'];
  $fechaZ = $_POST['fecha'];
  $horaZ = $_POST['hora']; 
  
  //Variables actuales de la fecha y hora
    date_default_timezone_set('America/Mexico_City');
    $fecha_actual1 = date("Y-m-d");
    $hora_actual1 = date("H:i");
  
  //Variables para la hora (se ocupa sólo en el update)
    $hora_rest = strtotime('+2 hours', strtotime($hora_actual1)); 
    $hora_rest = date('H:i',$hora_rest);
  
  //Variables de fecha actual + 2 dias...	
    $fecha_rest = strtotime('+2 days', strtotime($fecha_actual1)); 
    $fecha_rest = date("Y-m-d",$fecha_rest);
  
  //Variables de horario disponible
    $hora_ac_ini1 = date ("08:59");
    $hora_ac_fin1 = date ("14:00");
    $hora_ac_ini2 = date ("16:59");
    $hora_ac_fin2 = date ("21:00");
  
  //Variables para evitar citas entre horas
    $db = new DbOperacion();
    $minuto = explode(":",$horaZ);
    $minutoZ = $minuto['1'];
    //Logica de comprobacion de todo!!!!
    if($fecha_actual1 >= $fechaZ || $fechaZ > $fecha_actual1 && $fechaZ < $fecha_rest ){
      $response['error'] = true;
      $response['message'] = 'solo se pueden reagendar citas 2 dias despues de la fecha actual';
    }else{ 
      $db->eliminarHF($id_cita);
        $compHF = $db->comprobarFechaHora($fechaZ,$horaZ);
        if(count($compHF)>0){
        $db->agregarHF($id_cita,$horaZ,$fechaZ);
          $response['error'] = true;
          $response['message'] = 'La fecha y hora de esa cita ya se ha registrado anteriormente.';
        }else{
        if($minutoZ>0){
          $response['error'] = true;
          $response['message'] = 'No puedes agendar citas entre horas.';
        }else{
          if( ( $horaZ > $hora_ac_ini1 && $horaZ < $hora_ac_fin1) || ($horaZ > $hora_ac_ini2 && $horaZ < $hora_ac_fin2) ){
            if($db->actualizarCita($_POST['id_cita'], $_POST['asunto'] , $_POST['descripcion'], $_POST['fecha'], $_POST['hora'])){
              $response['error'] = false;
              $response['message'] = 'La cita se ha actualizado correctamente';
             }else{
             $response['error'] = true;
             $response['message'] = 'Ocurrion un error al intentar actualizar la cita';
            }    
        }else{
          $response['error'] = true;
          $response['message'] = 'Solo se pueden agendar citas de 9:00-14:00 y 17:00-21:00.';
        }
         }
      }
     }
   }else{
    $response['error'] = true;
    $response['message'] = 'Los parametros estan incompletos';
   }
break;

case 'eliminarCita':

  if(isset($_POST['id_cita']) && isset($_POST['fecha'])){
    $db = new DbOperacion();
    $fechaZ = $_POST['fecha'];
    //Variables actuales de la fecha y hora
    date_default_timezone_set('America/Mexico_City');
    $fecha_actual1 = date("Y-m-d");
    $hora_actual1 = date("H:i");
    //Variables de fecha actual + 2 dias...	
    $fecha_rest = strtotime('+2 days', strtotime($fecha_actual1)); 
    $fecha_rest = date("Y-m-d",$fecha_rest);
    
    if($fecha_actual1 >= $fechaZ || $fechaZ > $fecha_actual1 && $fechaZ < $fecha_rest ){
      $response['error'] = true;
      $response['message'] = 'solo se puede Cancelar citas 2 dias despues de la fecha actual';
    }else{ 

      if($db->eliminarCita($_POST['id_cita'])   ){
      $response['error'] = false;
      $response['message'] = 'La cita se ha eliminado Correctamente';
     }else{
     $response['error'] = true;
     $response['message'] = 'Ocurrion un error al intentar eliminar la cita';
    }


 }
  }else{
    $response['error'] = true;
    $response['message'] = 'Los parametros estan incompletos';
  }


break;


 //if it is getartist that means we are fetching the records
 /*case 'getUsuario':
 $db = new DbOperacion();
 $artists = $db->getArtists();
 if(count($artists)<=0){
   $response['error'] = true;
   $response['message'] = 'Nothing found in the database';
 }else{
   $response['error'] = false;
   $response['artists'] = $artists;
 }
 break;*/

 default:
 $response['error'] = true;
 $response['message'] = 'Operación no válida ';

 }

 }else{
 $response['error'] = false;
 $response['message'] = 'Peticion Invalida';
 }

 //displaying the data in json
 echo json_encode($response);
